Merge tag 'samsung-dt64-4.21-2' of https://git.kernel.org/pub/scm/linux/kernel/git...
[sfrench/cifs-2.6.git] / scripts / faddr2line
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Translate stack dump function offsets.
5 #
6 # addr2line doesn't work with KASLR addresses.  This works similarly to
7 # addr2line, but instead takes the 'func+0x123' format as input:
8 #
9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10 #   meminfo_proc_show+0x5/0x568:
11 #   meminfo_proc_show at fs/proc/meminfo.c:27
12 #
13 # If the address is part of an inlined function, the full inline call chain is
14 # printed:
15 #
16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17 #   native_write_msr+0x6/0x27:
18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21 #
22 # The function size after the '/' in the input is optional, but recommended.
23 # It's used to help disambiguate any duplicate symbol names, which can occur
24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
25 # multiple code sites to be printed:
26 #
27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28 #   raw_ioctl+0x5/0x20:
29 #   raw_ioctl at drivers/char/raw.c:122
30 #
31 #   raw_ioctl+0x5/0xb1:
32 #   raw_ioctl at net/ipv4/raw.c:876
33 #
34 # Multiple addresses can be specified on a single command line:
35 #
36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37 #   type_show+0x10/0x2d:
38 #   type_show at drivers/video/backlight/backlight.c:213
39 #
40 #   free_reserved_area+0x90/0x123:
41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44 set -o errexit
45 set -o nounset
46
47 READELF="${CROSS_COMPILE:-}readelf"
48 ADDR2LINE="${CROSS_COMPILE:-}addr2line"
49 SIZE="${CROSS_COMPILE:-}size"
50 NM="${CROSS_COMPILE:-}nm"
51
52 command -v awk >/dev/null 2>&1 || die "awk isn't installed"
53 command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed"
54 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed"
55 command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed"
56 command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed"
57
58 usage() {
59         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
60         exit 1
61 }
62
63 warn() {
64         echo "$1" >&2
65 }
66
67 die() {
68         echo "ERROR: $1" >&2
69         exit 1
70 }
71
72 # Try to figure out the source directory prefix so we can remove it from the
73 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
74 # init/main.c!  This only works for vmlinux.  Otherwise it falls back to
75 # printing the absolute path.
76 find_dir_prefix() {
77         local objfile=$1
78
79         local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
80         [[ -z $start_kernel_addr ]] && return
81
82         local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
83         [[ -z $file_line ]] && return
84
85         local prefix=${file_line%init/main.c:*}
86         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
87                 return
88         fi
89
90         DIR_PREFIX=$prefix
91         return 0
92 }
93
94 __faddr2line() {
95         local objfile=$1
96         local func_addr=$2
97         local dir_prefix=$3
98         local print_warnings=$4
99
100         local func=${func_addr%+*}
101         local offset=${func_addr#*+}
102         offset=${offset%/*}
103         local size=
104         [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
105
106         if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
107                 warn "bad func+offset $func_addr"
108                 DONE=1
109                 return
110         fi
111
112         # Go through each of the object's symbols which match the func name.
113         # In rare cases there might be duplicates.
114         file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}')
115         while read symbol; do
116                 local fields=($symbol)
117                 local sym_base=0x${fields[0]}
118                 local sym_type=${fields[1]}
119                 local sym_end=${fields[3]}
120
121                 # calculate the size
122                 local sym_size=$(($sym_end - $sym_base))
123                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
124                         warn "bad symbol size: base: $sym_base end: $sym_end"
125                         DONE=1
126                         return
127                 fi
128                 sym_size=0x$(printf %x $sym_size)
129
130                 # calculate the address
131                 local addr=$(($sym_base + $offset))
132                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
133                         warn "bad address: $sym_base + $offset"
134                         DONE=1
135                         return
136                 fi
137                 addr=0x$(printf %x $addr)
138
139                 # weed out non-function symbols
140                 if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
141                         [[ $print_warnings = 1 ]] &&
142                                 echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
143                         continue
144                 fi
145
146                 # if the user provided a size, make sure it matches the symbol's size
147                 if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
148                         [[ $print_warnings = 1 ]] &&
149                                 echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
150                         continue;
151                 fi
152
153                 # make sure the provided offset is within the symbol's range
154                 if [[ $offset -gt $sym_size ]]; then
155                         [[ $print_warnings = 1 ]] &&
156                                 echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
157                         continue
158                 fi
159
160                 # separate multiple entries with a blank line
161                 [[ $FIRST = 0 ]] && echo
162                 FIRST=0
163
164                 # pass real address to addr2line
165                 echo "$func+$offset/$sym_size:"
166                 local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
167                 [[ -z $file_lines ]] && return
168
169                 if [[ $LIST = 0 ]]; then
170                         echo "$file_lines" | while read -r line
171                         do
172                                 echo $line
173                         done
174                         DONE=1;
175                         return
176                 fi
177
178                 # show each line with context
179                 echo "$file_lines" | while read -r line
180                 do
181                         echo
182                         echo $line
183                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
184                         n1=$[$n-5]
185                         n2=$[$n+5]
186                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
187                         awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
188                 done
189
190                 DONE=1
191
192         done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
193 }
194
195 [[ $# -lt 2 ]] && usage
196
197 objfile=$1
198
199 LIST=0
200 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
201
202 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
203 shift
204
205 DIR_PREFIX=supercalifragilisticexpialidocious
206 find_dir_prefix $objfile
207
208 FIRST=1
209 while [[ $# -gt 0 ]]; do
210         func_addr=$1
211         shift
212
213         # print any matches found
214         DONE=0
215         __faddr2line $objfile $func_addr $DIR_PREFIX 0
216
217         # if no match was found, print warnings
218         if [[ $DONE = 0 ]]; then
219                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
220                 warn "no match for $func_addr"
221         fi
222 done